Why is processing a sorted array faster than an unsorted array(Stackoverflow)

What is Branch Prediction?Consider a railroad junction:Image by Mecanismo, via Wikimedia Commons. Used under the CC-By-SA 3.0 license.Now for the sake of argument, suppose this is back in the 1800s - before long distance or radio communication.You are the operator of a junction and you hear a train coming. You have no idea which way it will go. You stop the train to ask the captain which direction he wants. And then you set the switch appropriately.Trains are heavy and have a lot of inertia. So they take forever to start up and slow down.Is there a better way? You guess which direction the train will go!
If you guessed right, it continues on.
If you guessed wrong, the captain will stop, back up, and yell at you to flip the switch. Then it can restart down the other path.
If you guess right every time, the train will never have to stop.
If you guess wrong too often, the train will spend a lot of time stopping, backing up, and restarting.Consider an if-statement: At the processor level, it is a branch instruction:You are a processor and you see a branch. You have no idea which way it will go. What do you do? You halt execution and wait until the previous instructions are complete. Then you continue down the correct path.Modern processors are complicated and have long pipelines. So they take forever to "warm up" and "slow down".Is there a better way? You guess which direction the branch will go!
If you guessed right, you continue executing.
If you guessed wrong, you need to flush the pipeline and roll back to the branch. Then you can restart down the other path.
If you guess right every time, the execution will never have to stop.
If you guess wrong too often, you spend a lot of time stalling, rolling back, and restarting.This is branch prediction. I admit it‘s not the best analogy since the train could just signal the direction with a flag. But in computers, the processor doesn‘t know which direction a branch will go until the last moment.So how would you strategically guess to minimize the number of times that the train must back up and go down the other path? You look at the past history! If the train goes left 99% of the time, then you guess left. If it alternates, then you alternate your guesses. If it goes one way every 3 times, you guess the same...In other words, you try to identify a pattern and follow it. This is more or less how branch predictors work.Most applications have well-behaved branches. So modern branch predictors will typically achieve >90% hit rates. But when faced with unpredictable branches with no recognizable patterns, branch predictors are virtually useless.Further reading: "Branch predictor" article on Wikipedia.As hinted from above, the culprit is this if-statement:if(data[c]>=128)sum+=data[c];Notice that the data is evenly distributed between 0 and 255. When the data is sorted, roughly the first half of the iterations will not enter the if-statement. After that, they will all enter the if-statement.This is very friendly to the branch predictor since the branch consecutively goes the same direction many times.Even a simple saturating counter will correctly predict the branch except for the few iterations after it switches direction.Quick visualization:T=branch takenN=branchnottakendata[]=0,1,2,3,4,...126,127,128,129,130,...250,251,252,...branch=N  N  N  N  N...N    N    T    T    T...T    T    T...=NNNNNNNNNNNN...NNNNNNNTTTTTTTTT...TTTTTTTTTT(easy to predict)However, when the data is completely random, the branch predictor is rendered useless because it can‘t predict random data.Thus there will probably be around 50% misprediction. (no better than random guessing)data[]=226,185,125,158,198,144,217,79,202,118,14,150,177,182,133,...branch=T,T,N,T,T,T,T,N,T,N,N,T,T,T,N...=TTNTTTTNTNNTTTN...(completely random-hard to predict)So what can be done?If the compiler isn‘t able to optimize the branch into a conditional move, you can try some hacks if you are willing to sacrifice readability for performance.Replace:if(data[c]>=128)sum+=data[c];with:intt=(data[c]-128)>>31;sum+=~t&data[c];This eliminates the branch and replaces it with some bitwise operations.(Note that this hack is not strictly equivalent to the original if-statement. But in this case, it‘s valid for all the input values ofdata[].)Benchmarks: Core i7 920 @ 3.5 GHzC++ - Visual Studio 2010 - x64 Release//  Branch - Randomseconds=11.777//  Branch - Sortedseconds=2.352//  Branchless - Randomseconds=2.564//  Branchless - Sortedseconds=2.587Java - Netbeans 7.1.1 JDK 7 - x64//  Branch - Randomseconds=10.93293813//  Branch - Sortedseconds=5.643797077//  Branchless - Randomseconds=3.113581453//  Branchless - Sortedseconds=3.186068823Observations:
With the Branch: There is a huge difference between the sorted and unsorted data.
With the Hack: There is no difference between sorted and unsorted data.
In the C++ case, the hack is actually a tad slower than with the branch when the data is sorted.
A general rule of thumb is to avoid data-dependent branching in critical loops. (such as in this example)Update :
GCC 4.6.1 with -O3 or -ftree-vectorize on x64 is able to generate a conditional move. So there is no difference between the sorted and unsorted data - both are fast.
VC++ 2010 is unable to generate conditional moves for this branch even under /Ox.
Intel Compiler 11 does something miraculous. It interchanges the two loops, thereby hoisting the unpredictable branch to the outer loop. So not only is it immune the mispredictions, it is also twice as fast as whatever VC++ and GCC can generate! In other words, ICC took advantage of the test-loop to defeat the benchmark...
If you give the Intel Compiler the branchless code, it just out-right vectorizes it... and is just as fast as with the branch (with the loop interchange).
This goes to show that even mature modern compilers can vary wildly in their ability to optimize code...
  
每一次CPU执行这个条件判断时,CPU都可能跳转到循环开始处的指令,即不执行if后的指令。使用分支预测技术,当处理已经排序的数组时,在若干次data[c]>=128都不成立时(或第一次不成立时,取决于分支预测的实现),CPU预测这个分支是始终会跳转到循环开始的指令时,这个时候CPU将保持有效的执行,不需要重新等待到新的地址取指;同样,当data[c]>=128条件成立若干次后,CPU也可以预测这个分支是不必跳转的,那么这个时候CPU也可以保持高效执行。

相反,如果是无序的数组,CPU的分支预测在很大程度上都无法预测成功,基本就是50%的预测成功概率,这将消耗大量的时间,因为CPU很多时间都会等待取指单元重新取指。

时间: 2024-10-03 23:59:57

Why is processing a sorted array faster than an unsorted array(Stackoverflow)的相关文章

good article————K’th Smallest/Largest Element in Unsorted Array | Set 2 (Expected Linear Time)

这是本人在研究leetcode中Median of Two Sorted Arrays一题目的时候看到一篇文章,觉得非常好,其中对快速排序重新实现. 文章来源于http://www.geeksforgeeks.org/这个网站. We recommend to read following post as a prerequisite of this post. K'th Smallest/Largest Element in Unsorted Array | Set 1 Given an ar

[GeeksForGeeks] Find the largest pair sum in an unsorted array

Given an unsorted array, find the largest pair sum. Solution 1. O(n*logn) runtime, using sorting Solution 2. O(n) runtime, using heapify (max priority queue) Option 1. Use Java priority queue API, easy to implement but uses O(n) extra memory. Option

108.Convert Sorted Array to Binary Search Tree(Array; Divide-and-Conquer, dfs)

Given an array where elements are sorted in ascending order, convert it to a height balanced BST. 思路:使用二分法,将list的中间节点作为根节点,然后分别处理list左半边及右半边,以此递归. struct TreeNode { int val; TreeNode *left; TreeNode *right; TreeNode(int x) : val(x), left(NULL), right

Kth Smallest Element in Unsorted Array

(referrence: GeeksforGeeks, Kth Largest Element in Array) This is a common algorithm problem appearing in interviews. There are four basic solutions. Solution 1 -- Sort First A Simple Solution is to sort the given array using a O(n log n) sorting alg

JavaScript,通过分析Array.prototype.push重新认识Array

在阅读ECMAScript的文档的时候,有注意到它说,数组的push方法其实不仅限于在数组中使用,专门留作通用方法.难道是说,在一些类数组的地方也可以使用?而哪些是和数组非常相像的呢,大家或许一下子就可以想到就是Object对象.因为Array就是继承自Object的,可以用 [] instanceof Object,会发现返回的是true.当然大家都知道,这也不是什么新鲜事.那我们可以大胆尝试一下,如果我们将数组的push方法应用在对象上,会一个怎么样的表现呢? 我们通过call,将this的

[ES2016] Check if an array contains an item using Array.prototype.includes

We often want to check if an array includes a specific item. It's been common to do this with the Array.prototype.indexOf method, but now we have a simpler way: We can use the Array.prototype.includes method, which is available starting with ES2016.

numpy array转置与两个array合并

我们知道,用 .T 或者 .transpose() 都可以将一个矩阵进行转置. 但是一维数组转置的时候有个坑,光transpose没有用,需要指定shape参数, 在array中,当维数>=2,时这个成立,但=1时,就不成立了,如: In [7]: yOut[7]: array([0, 0, 0, 0, 0]) In [14]: y.TOut[14]: array([0, 0, 0, 0, 0]) In [15]: y.transpose()Out[15]: array([0, 0, 0, 0,

找出最大连续自然数个数[Longest Consecutive Sequence in an Unsorted Array]

[本文链接] http://www.cnblogs.com/hellogiser/p/Longest-Consecutive-Sequence-in-an-Unsorted-Array.html [题目] 一个无序自然数数组,比如[100,2,1,3]求在0(n)时间复杂度内求出最大的连续自然数个数:输出应该是3 [分析] 方法一:排序可以采用一些排序方法比如基数排序.桶排序.记数排序等先进行排序.然后遍历一遍所有元素即可.当前这些排序有一些限制条件的. 方法二:维持一个hash表维持一个has

浅谈分支预测、流水线与条件转移(转载)

一 一个问题 原文链接:http://www.cnblogs.com/yangecnu/p/4196026.html#undefined 在StackOverflow上有这么一个问题 Why is processing a sorted array faster than an unsorted array? .例子中,对一个数组进行条件求和,在排序前和排序后,性能有很大的差别.原始的例子是C++和Java的,这里将其换成了C# : static void Main(string[] args)